#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DrawOutline");
#include <ft2build.h>
#include FT_FREETYPE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	FT_Face face;
	unsigned index;
	int c,p;
	int cs,ce;
	FT_Vector pt;
	int x,y;

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);

		FT_New_Face(library,"c:\\windows\\fonts\\batang.ttc",2,&face);
		FT_Set_Char_Size(face, 256 * 64, 0, 
			GetDeviceCaps(hdc,LOGPIXELSX), GetDeviceCaps(hdc,LOGPIXELSY));
		index = FT_Get_Char_Index(face,L'');
		FT_Load_Glyph(face,index,FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP);

		for (c=0;c<face->glyph->outline.n_contours;c++) {
			//  ,  ε ã
			cs=(c==0 ? 0:face->glyph->outline.contours[c-1]+1);
			ce=face->glyph->outline.contours[c];
			for (p=cs;p<=ce;p++) {
				pt=face->glyph->outline.points[p];
				x=pt.x >> 6;
				y=pt.y >> 6;
				if (p==cs) {
					MoveToEx(hdc,x,300-y,NULL);
				} else {
					LineTo(hdc,x,300-y);
				}
				Sleep(10);
			}
			//  
			pt=face->glyph->outline.points[cs];
			x=pt.x >> 6;
			y=pt.y >> 6;
			LineTo(hdc,x,300-y);
		}

		FT_Done_Face(face);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
