#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("Kerning");
#include <ft2build.h>
#include FT_FREETYPE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

void DrawGlyph(HDC hdc,int bx, int by, FT_Face face)
{
	int x, y;
	int Color;
	int width, height;
	width=face->glyph->bitmap.width;
	height=face->glyph->bitmap.rows;

	for (y=0;y<height;y++) {
		for (x=0;x<width;x++) {
			Color=255-face->glyph->bitmap.buffer[y*width+x];
			if (Color != 255) {
				SetPixelV(hdc,bx+face->glyph->bitmap_left+x,
					by-face->glyph->bitmap_top+y,RGB(Color,Color,Color));
			}
		}
	}
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	FT_Face face;
	static TCHAR str[]=TEXT("AV T.Test");
	int idx;
	int penx,peny;
	unsigned left=0,right=0;
	FT_Vector kerning;

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);

		FT_New_Face(library,"c:\\windows\\fonts\\times.ttf",0,&face);
		FT_Set_Char_Size(face, 128 * 64, 0, 
			GetDeviceCaps(hdc,LOGPIXELSX), GetDeviceCaps(hdc,LOGPIXELSY));

		// Ŀ 
		penx=0 * 64;
		peny=150 * 64;
		for (idx=0;idx<lstrlen(str);idx++) {
			FT_Load_Char(face,str[idx],FT_LOAD_RENDER | FT_LOAD_NO_BITMAP);
			DrawGlyph(hdc,(penx >> 6), (peny >> 6), face);
			penx += face->glyph->advance.x;
			peny += face->glyph->advance.y;
		}

		// Ŀ 
		if (FT_HAS_KERNING(face)) {
			penx=0 * 64;
			peny=300 * 64;
			for (idx=0;idx<lstrlen(str);idx++) {
				right = FT_Get_Char_Index(face,str[idx]);
				if (left != 0) {
					FT_Get_Kerning(face,left,right,FT_KERNING_DEFAULT,&kerning);
					penx += kerning.x;;
				}
				FT_Load_Glyph(face,right,FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP);
				FT_Render_Glyph(face->glyph, FT_RENDER_MODE_NORMAL);
				DrawGlyph(hdc,(penx >> 6), (peny >> 6), face);
				penx += face->glyph->advance.x;
				peny += face->glyph->advance.y;
				left=right;
			}
		}

		FT_Done_Face(face);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
