#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DumpMetrics");
#include <ft2build.h>
#include FT_FREETYPE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

// Ʈ  
#define OUTSTR(x) TextOut(hdc,x,y++*20,str,lstrlen(str))
void DrawMetrics(HDC hdc)
{
	FT_Face face;
	TCHAR str[128];
	int y=0;

	// Times
	FT_New_Face(library,"c:\\windows\\fonts\\times.ttf",0,&face);

	// ü
	//FT_New_Face(library,"c:\\windows\\fonts\\batang.ttc",2,&face);

	// Ʈ Ʈ
	wsprintf(str,TEXT("num_faces : %d"),face->num_faces);OUTSTR(0);
	wsprintf(str,TEXT("face_index : %d"),face->face_index);OUTSTR(0);
	wsprintf(str,TEXT("face_flags : %x"),face->face_flags);OUTSTR(0);
	wsprintf(str,TEXT("style_flags : %x"),face->style_flags);OUTSTR(0);
	wsprintf(str,TEXT("num_glyphs : %d"),face->num_glyphs);OUTSTR(0);
	wsprintf(str,TEXT("family_name : %S"),face->family_name);OUTSTR(0);
	wsprintf(str,TEXT("style_name : %S"),face->style_name);OUTSTR(0);
	wsprintf(str,TEXT("num_fixed_sizes : %d"),face->num_fixed_sizes);OUTSTR(0);
	wsprintf(str,TEXT("num_charmaps : %d"),face->num_charmaps);OUTSTR(0);
	wsprintf(str,TEXT("bbox : %d,%d,%d,%d"),face->bbox.xMin,face->bbox.xMax,face->bbox.yMin,face->bbox.yMax);OUTSTR(0);
	wsprintf(str,TEXT("units_per_EM : %d"),face->units_per_EM);OUTSTR(0);
	wsprintf(str,TEXT("ascender : %d"),face->ascender);OUTSTR(0);
	wsprintf(str,TEXT("descender : %d"),face->descender);OUTSTR(0);
	wsprintf(str,TEXT("height : %d"),face->height);OUTSTR(0);
	wsprintf(str,TEXT("max_advance_width : %d"),face->max_advance_width);OUTSTR(0);
	wsprintf(str,TEXT("max_advance_height : %d"),face->max_advance_height);OUTSTR(0);
	wsprintf(str,TEXT("underline_position : %d"),face->underline_position);OUTSTR(0);
	wsprintf(str,TEXT("underline_thickness : %d"),face->underline_thickness);OUTSTR(0);

	//  Ʈ
	FT_Set_Char_Size(face, 20 * 64, 0, 
		GetDeviceCaps(hdc,LOGPIXELSX), GetDeviceCaps(hdc,LOGPIXELSY)); 
	y=0;
	wsprintf(str,TEXT("x_ppem : %d"),face->size->metrics.x_ppem);OUTSTR(300);
	wsprintf(str,TEXT("x_scale : %d"),face->size->metrics.x_scale);OUTSTR(300);
	wsprintf(str,TEXT("y_ppem : %d"),face->size->metrics.y_ppem);OUTSTR(300);
	wsprintf(str,TEXT("y_scale : %d"),face->size->metrics.y_scale);OUTSTR(300);
	wsprintf(str,TEXT("ascender : %d"),face->size->metrics.ascender);OUTSTR(300);
	wsprintf(str,TEXT("descender : %d"),face->size->metrics.descender);OUTSTR(300);
	wsprintf(str,TEXT("height : %d"),face->size->metrics.height);OUTSTR(300);
	wsprintf(str,TEXT("max_advance : %d"),face->size->metrics.max_advance);OUTSTR(300);

	// ۸ Ʈ. ϸ Ʈ 
	FT_Load_Glyph(face,FT_Get_Char_Index(face,'S'),FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP);
	FT_Render_Glyph(face->glyph, FT_RENDER_MODE_NORMAL);
	y=0;
	wsprintf(str,TEXT("format : %s"),face->glyph->format==FT_GLYPH_FORMAT_OUTLINE ? L"Outline":L"Bitmap");OUTSTR(600);
	wsprintf(str,TEXT("advance.x : %d"),face->glyph->advance.x);OUTSTR(600);
	wsprintf(str,TEXT("advance.y : %d"),face->glyph->advance.y);OUTSTR(600);
	wsprintf(str,TEXT("width : %d"),face->glyph->metrics.width);OUTSTR(600);
	wsprintf(str,TEXT("height : %d"),face->glyph->metrics.height);OUTSTR(600);
	wsprintf(str,TEXT("horiBearingX : %d"),face->glyph->metrics.horiBearingX);OUTSTR(600);
	wsprintf(str,TEXT("horiBearingY : %d"),face->glyph->metrics.horiBearingY);OUTSTR(600);
	wsprintf(str,TEXT("horiAdvance : %d"),face->glyph->metrics.horiAdvance);OUTSTR(600);
	wsprintf(str,TEXT("vertBearingX : %d"),face->glyph->metrics.vertBearingX);OUTSTR(600);
	wsprintf(str,TEXT("vertBearingY : %d"),face->glyph->metrics.vertBearingY);OUTSTR(600);
	wsprintf(str,TEXT("vertAdvance : %d"),face->glyph->metrics.vertAdvance);OUTSTR(600);
	wsprintf(str,TEXT("bitmap_left : %d"),face->glyph->bitmap_left);OUTSTR(600);
	wsprintf(str,TEXT("bitmap_top : %d"),face->glyph->bitmap_top);OUTSTR(600);
	wsprintf(str,TEXT("bitmap.width : %d"),face->glyph->bitmap.width);OUTSTR(600);
	wsprintf(str,TEXT("bitmap.rows : %d"),face->glyph->bitmap.rows);OUTSTR(600);
	wsprintf(str,TEXT("bitmap.pitch : %d"),face->glyph->bitmap.pitch);OUTSTR(600);
	wsprintf(str,TEXT("n_contours : %d"),face->glyph->outline.n_contours);OUTSTR(600);
	wsprintf(str,TEXT("n_points : %d"),face->glyph->outline.n_points);OUTSTR(600);

	FT_Done_Face(face);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		DrawMetrics(hdc);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
