#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("ResPixel");
#include <ft2build.h>
#include FT_FREETYPE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

int g_pt;
int g_res;
LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	FT_Face face;
	int x, y;
	int Color;
	int width, height;
	TCHAR Status[128];

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		g_pt=32;
		g_res=96;
		return 0;
	case WM_KEYDOWN:
		switch (wParam) {
		case VK_UP:
			g_pt += 10;
			InvalidateRect(hWnd,NULL,TRUE);
			break;
		case VK_DOWN:
			g_pt -= 10;
			InvalidateRect(hWnd,NULL,TRUE);
			break;
		case VK_RIGHT:
			g_res += 10;
			InvalidateRect(hWnd,NULL,TRUE);
			break;
		case VK_LEFT:
			g_res -= 10;
			InvalidateRect(hWnd,NULL,TRUE);
			break;
		}
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);

		FT_New_Face(library,"c:\\windows\\fonts\\batang.ttc",2,&face);
		FT_Set_Char_Size(face, g_pt * 64, 0, g_res, 0);
		FT_Load_Char(face,TEXT(''),FT_LOAD_RENDER | FT_LOAD_NO_BITMAP);

		// ȭ 
		width=face->glyph->bitmap.width;
		height=face->glyph->bitmap.rows;

		for (y=0;y<height;y++) {
			for (x=0;x<width;x++) {
				Color=255-face->glyph->bitmap.buffer[y*width+x];
				if (Color != 255) {
					SetPixelV(hdc,0+face->glyph->bitmap_left+x,
						300-face->glyph->bitmap_top+y,RGB(Color,Color,Color));
				}
			}
		}

		wsprintf(Status, TEXT("pt=%d, res=%d, width=%d, rows=%d"),g_pt, g_res, width, height);
		TextOut(hdc,0,0,Status,lstrlen(Status));
		FT_Done_Face(face);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
