#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("Transform");
#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_OUTLINE_H
FT_Library library;

#pragma comment(lib,"..\\..\\freetype237MT.lib")

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	// ̺귯 ʱȭ
	if (FT_Init_FreeType(&library)) {
		MessageBox(NULL,TEXT("FreeType ̺귯 ʱȭ "),
			TEXT(""),MB_OK);
		return -1;
	}

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while (GetMessage(&Message,NULL,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	// ̺귯 
	FT_Done_FreeType(library);
	return (int)Message.wParam;
}

#include <math.h>
void DrawGlyph(HDC hdc,int bx, int by, FT_Face face)
{
	int x, y;
	int Color;
	int width, height;
	width=face->glyph->bitmap.width;
	height=face->glyph->bitmap.rows;

	for (y=0;y<height;y++) {
		for (x=0;x<width;x++) {
			Color=255-face->glyph->bitmap.buffer[y*width+x];
			if (Color != 255) {
				SetPixelV(hdc,bx+face->glyph->bitmap_left+x,
					by-face->glyph->bitmap_top+y,RGB(Color,Color,Color));
			}
		}
	}
}

void OnPaint(HDC hdc)
{
	FT_Face face;
	unsigned index;

	FT_New_Face(library,"c:\\windows\\fonts\\batang.ttc",2,&face);
	FT_Set_Char_Size(face, 64 * 64, 0, 
		GetDeviceCaps(hdc,LOGPIXELSX), GetDeviceCaps(hdc,LOGPIXELSY));
	index = FT_Get_Char_Index(face,L'');

	//  ķ 
	FT_Matrix matrix = { 0x10000,0x00000,0x00000,0x10000 };

	/* 2 Ȯ
	matrix.xx = 0x20000;
	matrix.yy = 0x20000;
	//*/

	/* θ 5 Ȯ
	matrix.xx = 0x50000;
	matrix.yy = 0x10000;
	//*/

	/* θ  
	matrix.xx = 0x08000;
	//*/

	/*  
	matrix.xx = -0x10000;
	//*/

	/* ̱
	matrix.xy = 0x06000;
	//*/

	//* 45  ȸ
	double angle=(45.0/360)*3.14159*2;
	matrix.xx = (FT_Fixed)(cos(angle)*0x10000);
	matrix.xy = (FT_Fixed)(-sin(angle)*0x10000);
	matrix.yx = (FT_Fixed)(sin(angle)*0x10000);
	matrix.yy = (FT_Fixed)(cos(angle)*0x10000);
	//*/

	FT_Load_Glyph(face,index,FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP);
	FT_Outline_Transform( &face->glyph->outline, &matrix );
	FT_Render_Glyph(face->glyph, FT_RENDER_MODE_NORMAL);
	DrawGlyph(hdc,200,200,face);

	FT_Done_Face(face);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMessage) {
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
